/**
 * @file
 * Core views facets AJAX handling.
 */

(function ($) {
  'use strict';

  /**
   Trigger views AJAX refresh on click.
   */
  Drupal.behaviors.coreViewsFacetsViewsAjax = {
    attach: function (context, settings) {

      $.each(settings.core_views_facets, function (facetId, facetSettings) {
        $('ul[data-drupal-facet-id=' + facetId + ']  li a').once().click(function (e) {
          e.preventDefault();
          var facetLink = $(this);
          $('.view-id-' + facetSettings.view_id + '.view-display-id-' + facetSettings.current_display_id).each(function (view_index, view) {
            view = $(view);

            var start = view.attr('class').indexOf('js-view-dom-id-');
            var end = view.attr('class').indexOf(' ', start);
            var current_dom_id = view.attr('class').substr(start + 15, (view.attr('class').length - start - 15 - end));

            if (typeof Drupal.views.instances['views_dom_id:' + current_dom_id] === 'undefined') {
              return;
            }

            if (facetSettings.type === 'core_views_exposed_filter') {
              if (facetLink.hasClass('is-active')) {
                delete Drupal.views.instances['views_dom_id:' + current_dom_id].settings[facetSettings.field_id];
              }
              else {
                Drupal.views.instances['views_dom_id:' + current_dom_id].settings[facetSettings.field_id] = facetLink.data('drupal-facet-item-id').substr(facetId.length + 1);
              }
            }
            else if (facetSettings.type === 'core_views_contextual_filter') {
              Drupal.views.instances['views_dom_id:' + current_dom_id].settings.view_args = facetLink
                .attr('href')
                .replace(drupalSettings.path.baseUrl, '')
                .replace(Drupal.views.instances['views_dom_id:' + current_dom_id].settings.view_base_path + '/', '');
              Drupal.views.instances['views_dom_id:' + current_dom_id].settings.view_path = facetLink.attr('href');
            }

            view.trigger('RefreshView');
          });
        });
      });
    }
  };

})(jQuery);
